<?php
#
#   FILE:  SPT--SavedSearch.php
#
#   FUNCTIONS PROVIDED:
#
#   FUNCTIONS EXPECTED:
#
#   Part of the Scout Portal Toolkit
#   Copyright 2003 Internet Scout Project
#   http://scout.cs.wisc.edu
#

require_once("include/SPT--Common.php");
require_once("include/SPT--SavedSearch.php");

CheckAuthorization();
PageTitle("Manage Saved Searches");


# ----- EXPORTED FUNCTIONS ---------------------------------------------------

function PrintSavedSearches()
{
    global $SysConfig;
    global $User;
    $Searches = GetSavedSearchesForUser($User->Id());
    if ($User->HasPriv(PRIV_RESOURCEADMIN))
    {
        $FreqList = SavedSearch::GetSearchFrequencyList();
    }
    else
    {
        $FreqList = SavedSearch::GetSearchFrequencyList(SEARCHFREQ_HOURLY);
    }

    # if no saved searches found
    if (count($Searches) == 0)
    {
        # add message indicating no saved searches
	?>
	<tr valign="top">
	    <td colspan="4">
	        There are no searches currently saved.<br>
		You can enter and save a search via the <a href="SPT--Advanced.php">Advanced Search</a> page.</td>
	</tr>
	<?PHP
    }
    else
    {
        # add table row for each saved search
        foreach ($Searches as $SearchId => $Search)
        {
            ?>
    
            <tr valign="top">
                <th align="left"><div style="margin-top: 5px;"><a href="SPT--AdvancedSearch.php?Q=Y&<?PHP  print($Search->TranslateSearchGroupsToUrlParameters());  ?>"><?PHP  print($Search->SearchName());  ?></a></div></th>
                <td><div class="editbutton" style="float: left;">
    	        <a href="SPT--Advanced.php?SI=<?PHP  print($SearchId);  ?>">Edit</a>
    	    </div></td>
                <td><div class="editbutton" style="float: left;">
    	        <a href="SPT--SavedSearch.php?AC=Delete&SI=<?PHP  print($SearchId);  ?>">Delete</a>
    	    </div></td>
    
    	    <?PHP  if ($SysConfig->UserAgentsEnabled()) {  ?>
                <td><?PHP  PrintOptionList("F_Frequency_".$SearchId, $FreqList, $Search->Frequency(), TRUE);  ?></td>
                <?PHP  }  ?>
    
                <td><div style="margin-top: 5px;"><?PHP  print($Search->GetSearchGroupsAsTextDescription(NULL, TRUE, FALSE));  ?></div></td>
            </tr>
    
    	<?PHP
        }
    }
}

# ----- LOCAL FUNCTIONS ------------------------------------------------------


# ----- MAIN -----------------------------------------------------------------

# if user asked to save new search
if (isset($HTTP_POST_VARS["Submit"]) && $HTTP_POST_VARS["Submit"] == "Save")
{
    # if reasonable search name was supplied
    if (isset($HTTP_POST_VARS["F_SearchName"]) && strlen($HTTP_POST_VARS["F_SearchName"]))
    {
        # save search
        $NewSavedSearch =& new SavedSearch(NULL, $HTTP_POST_VARS["F_SearchName"],
                $User->Id(), SEARCHFREQ_NEVER,
                SavedSearch::TranslateUrlParametersToSearchGroups($HTTP_GET_VARS));
    }
    else
    {
        # set error message and return back to new saved search page
    }
}
# else if user asked to delete search
elseif (isset($HTTP_GET_VARS["AC"]) && ($HTTP_GET_VARS["AC"] == "Delete"))
{
    # delete specified search
    $Search =& new SavedSearch($HTTP_GET_VARS["SI"]);
    $Search->Delete();
}
# else if user asked to change search frequency
elseif (isset($HTTP_POST_VARS["AC"]) && ($HTTP_POST_VARS["AC"] == "ChangeFrequency"))
{
    # for each saved search
    $Searches = GetSavedSearchesForUser($User->Id());
    foreach ($Searches as $Search)
    {
        # if frequency has changed
        if (isset($HTTP_POST_VARS["F_Frequency_".$Search->GetSearchId()])
                && ($HTTP_POST_VARS["F_Frequency_".$Search->GetSearchId()] != $Search->Frequency()))
        {
            # update frequency
            $Search->Frequency($HTTP_POST_VARS["F_Frequency_".$Search->GetSearchId()]);
        }
    }
}

include("include/SPT--StandardHtmlPageLoad.php");

?>
